//
//  SuggestionsInteractor.swift
//  VKExt
//
//  Created programmist_NA on 12.07.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit

class SuggestionsInteractor: SuggestionsInteractorProtocol {
    weak var presenter: SuggestionsPresenterProtocol?
    var service: NewsfeedService?

    func start(request: Newsfeed.Model.Request.RequestType) {
        makeRequest(request: request)
    }
    
    func makeRequest(request: Newsfeed.Model.Request.RequestType) {
        if service == nil {
            service = NewsfeedService()
        }
        
        switch request {
        case .getSuggestions:
            self.presenter?.presentData(response: Newsfeed.Model.Response.ResponseType.presentFooterLoader)
            service?.getSuggestions(completion: { [weak self] (revealedPostIds, feed) in
                guard let self = self else { return }
                self.presenter?.presentData(response: Newsfeed.Model.Response.ResponseType.presentSuggestions(feed: feed, revealdedPostIds: revealedPostIds))
            }, failed: { [weak self] error in
                    guard let self = self else { return }
                    self.presenter?.presentData(response: .presentFooterError(message: error))
            })
        case .revealPostIds(let postId):
            service?.revealPostIds(forPostId: postId, completion: { [weak self] (revealedPostIds, feed) in
                guard let self = self else { return }
                self.presenter?.presentData(response: Newsfeed.Model.Response.ResponseType.presentSuggestions(feed: feed, revealdedPostIds: revealedPostIds))
            })
        case .getNextBatch:
            self.presenter?.presentData(response: Newsfeed.Model.Response.ResponseType.presentFooterLoader)
            service?.getNextBatchRecomendations(completion: { [weak self] (revealedPostIds, feed) in
                guard let self = self else { return }
                self.presenter?.presentData(response: Newsfeed.Model.Response.ResponseType.presentSuggestions(feed: feed, revealdedPostIds: revealedPostIds))
            }, failed: { [weak self] error in
                    guard let self = self else { return }
                    self.presenter?.presentData(response: .presentFooterError(message: error))
            })
        case .like(let postId, let sourceId, let type):
            service?.addLikePost(type: type, ownerId: sourceId, itemId: postId)
        case .unlike(let postId, let sourceId, let type):
            service?.deleteLikePost(type: type, ownerId: sourceId, itemId: postId)
        default:
            break
        }
    }
}
